part of insync;

abstract class AbstractCollectionOrderer<V, C extends AbstractCollection<V>> extends Owner {
  C _source;
  C get source => _source;

  AbstractList<V> _target;
  AbstractList<V> get target => _target;

  AbstractCollectionOrderer(this._source, {AbstractList<V> target}) {
    assert(_source != null);
    _target = (target != null) ? target : _source.createEmptyList()..ownBy(this);
    _target.tryAddAll(_source.asList());
  }

  void destroy() {
    _target.removeValues(_source.asList());
    super.destroy();
  }

  void _splice(Set<V> removedValuesSet, Set<V> addedValuesSet) {
    List<V> filteredValues = _target.filter(
        (V v) => !removedValuesSet.contains(v) || addedValuesSet.contains(v));
    List<IndexCount> filteredParamsList = _target.detectFilter(filteredValues);
    List<V> addedValues = addedValuesSet.where(
        (V v) => !removedValuesSet.contains(v)).toList(growable: false);
    _target.trySplice(
        (filteredParamsList != null) ? filteredParamsList : [],
        [new IndexValues(filteredValues.length, addedValues)]);
  }
}