part of insync;

class AbstractListInserter<V> extends Owner {
  Function _addValue;
  Function _removeValue;
  Function _clearValues;

  AbstractList<V> _source;
  AbstractList<V> get source => _source;

  AbstractListInserter(this._source, {void add(V value, int index),
    void remove(V value, int index), void clear(List<V> values)}) :
    _addValue = add,
    _removeValue = remove,
    _clearValues = clear {
    assert(_source != null);
    _add(_source.list, 0);
  }

  void destroy() {
    _clear(_source.list);
    super.destroy();
  }

  void _add(List<V> values, int index) {
    if (_addValue == null) {
      return;
    }
    for (int i = 0; i < values.length; ++i) {
      _addValue(values[i], i + index);
    }
  }

  void _remove(List<V> values, int index) {
    if (_removeValue == null) {
      return;
    }
    for (int i = values.length - 1; i >= 0; --i) {
      _removeValue(values[i], i + index);
    }
  }

  void _clear(List<V> values) {
    if (values.isEmpty) {
      return;
    }
    if (_clearValues != null) {
      _clearValues(values);
    } else {
      _remove(values, 0);
    }
  }
}