part of insync;

class AbstractListMapper<S, T> extends
AbstractCollectionMapper<S, T, AbstractList<S>, AbstractList<T>> {

  AbstractListMapper(AbstractList<S> source,
      {AbstractList<T> target, T create(S data), void destroy(T item, S data)}) :
      super(source, target: target, create: create, destroy: destroy) {
    _target.tryAddAll(_create(_source.list));
  }

  void destroy() {
    _destroy(_target.clear(), _source.list);
    super.destroy();
  }

  List<T> _create(List<S> datas) {
    return new List.generate(datas.length, (int i) => _createItem(datas[i]));
  }

  void _destroy(List<T> items, List<S> datas) {
    if (_destroyItem == null) {
      return;
    }
    for (int i = items.length - 1; i >= 0; --i) {
      _destroyItem(items[i], datas[i]);
    }
  }
}