part of insync;

class AbstractSetMapper<S, T> extends AbstractCollectionMapper<S, T, AbstractSet<S>, AbstractSet<T>> {

  Map<S, T> _items = new HashMap<S, T>();

  AbstractSetMapper(AbstractSet<S> source,
      {AbstractSet<T> target, T create(S data), void destroy(T item, S data)}) :
      super(source, target: target, create: create, destroy: destroy) {
    _target.tryAddAll(_create(_source.toList()));
  }

  void destroy() {
    List<S> datas = _source.toList();
    _target.tryRemoveAll(_get(datas));
    _destroy(datas);
    super.destroy();
  }

  List<T> _get(List<S> datas) {
    return datas.map((S data) => _items[data]).toList(growable: true);
  }

  List<T> _create(List<S> datas) {
    List<T> items = new List<T>();
    for (int i = 0, l = datas.length; i < l; ++i) {
      S data = datas[i];
      T item = _createItem(data);
      items.add(item);
      _items[data] = item;
    }
    return items;
  }

  void _destroy(List<S> datas) {
    if (_destroyItem == null) {
      return;
    }
    for (int i = datas.length - 1; i >= 0; --i) {
      S data = datas[i];
      T item = _items[data];
      _items.remove(data);
      _destroyItem(item, data);
    }
  }
}