part of insync;

class ObservableListOrderer<V> extends AbstractListOrderer<V> {
  ObservableListOrderer(ObservableList<V> source, {AbstractList<V> target}) :
    super(source, target: target) {
    own(source.onSplice.listen(_onSplice));
    own(source.onReplace.listen(_onReplace));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(ObservableListSpliceEventParams<V> params) {
    ListSpliceResult<V> spliceResult = params.spliceResult;
    _splice(
        spliceResult.removedValues.toSet(),
        spliceResult.addedValues.toSet());
  }

  void _onReplace(ObservableListReplaceEventParams<V> params) {
    int index = _target.keyOf(params.oldValue);
    _target.trySplice(
        [new IndexCount(index, 1)],
        [new IndexValues(_target.length - 1, [params.newValue])]);
  }

  void _onClear(List<V> values) {
    _target.removeValues(values);
  }
}