part of insync;

class ObservableListSorterComparing<V> extends AbstractListSorterComparing<V> {
  ObservableListSorterComparing(ObservableList<V> source, {AbstractList<V> target,
    int compare(V x, V y)}) : super(source, target: target, compare: compare) {
    own(source.onSplice.listen(_onSplice));
    own(source.onReplace.listen(_onReplace));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(ObservableListSpliceEventParams<V> params) {
    ListSpliceResult<V> spliceResult = params.spliceResult;
    _splice(spliceResult.removedValues, spliceResult.addedValues);
  }

  void _onReplace(ObservableListReplaceEventParams<V> params) {
    _splice([params.oldValue], [params.newValue]);
  }

  void _onClear(List<V> values) {
    _splice(values, []);
  }
}