part of insync;

class ObservableMapFilterer<K, V> extends AbstractMapFilterer<K, V> {
  ObservableMapFilterer(ObservableMap<K, V> source, {AbstractMap<K, V> target,
    bool filter(V value)}) : super(source, target: target, filter: filter) {
    own(source.onSplice.listen(_onSplice));
    own(source.onReindex.listen(_onReindex));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(MapSpliceResult<K, V> spliceResult) {
    _target.trySplice(
        spliceResult.removedValues.keys.toList(growable: false),
        spliceResult.$addedValues.filter(_filterValue));
  }

  void _onReindex(Map<K, K> keyMap) {
    _target.tryReindex(keyMap);
  }

  void _onClear(Map<K, V> values) {
    _target.tryRemoveAll(values.keys.toList(growable: false));
  }
}