part of insync;

class ObservableMapInserter<K, V> extends AbstractMapInserter<K, V> {
  ObservableMapInserter(ObservableMap<K, V> source, {void add(V value, K key),
      void remove(V value, K key), void clear(Map<K, V> values)}) :
      super(source, add: add, remove: remove, clear: clear) {
    own(source.onSplice.listen(_onSplice));
    own(source.onReindex.listen(_onReindex));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(MapSpliceResult<K, V> spliceResult) {
    _remove(spliceResult.removedValues);
    _add(spliceResult.addedValues);
  }

  void _onReindex(Map<K, K> keyMap) {
    for (K oldKey in keyMap.keys) {
      K newKey = keyMap[oldKey];
      V value = _source[newKey];
      if (_removeItem != null) {
        _removeItem(value, oldKey);
      }
      if (_addItem != null) {
        _addItem(value, newKey);
      }
    }
  }

  void _onClear(Map<K, V> values) {
    _clear(values);
  }
}