part of insync;

class ObservableMapMapper<K, S, T> extends AbstractMapMapper<K, S, T> {
  ObservableMapMapper(ObservableMap<K, S> source,
      {AbstractMap<K, T> target, T create(S data), void destroy(T item, S data)}) :
      super(source, target: target, create: create, destroy: destroy) {
    own(source.onSplice.listen(_onSplice));
    own(source.onReindex.listen(_onReindex));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(MapSpliceResult<K, S> sourceResult) {
    Map<K, S> removedDatas = sourceResult.removedValues;
    Map<K, S> addedDatas = sourceResult.addedValues;
    MapSpliceResult<K, T> targetResult = _target.trySplice(
      new MapUtil<K, S>().getRemovedKeys(removedDatas, addedDatas),
      _create(addedDatas));
    if (targetResult != null) {
      _destroy(targetResult.removedValues, removedDatas);
    }
  }

  void _onReindex(Map<K, K> keyMap) {
    _target.tryReindex(keyMap);
  }

  void _onClear(Map<K, S> datas) {
    _destroy(_target.tryRemoveAll(datas.keys), datas);
  }
}