part of insync;

class ObservableSetObserver<V> extends AbstractSetObserver<V> {
  ObservableSetObserver(ObservableSet<V> source, {void add(V value), void remove(V value),
    void clear(List<V> values), void change()}) :
      super(source, add: add, remove: remove, clear: clear, change: change) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
    if (_change != null) {
      own(source.onChange.listen((p) { _change(); }));
    }
  }

  void _onSplice(SetSpliceResult<V> spliceResult) {
    _remove(spliceResult.removedValues);
    _add(spliceResult.addedValues);
  }

  void _onClear(List<V> values) {
    _clear(values);
  }
}