part of insync;

class EventDispatcher<P> extends Destroyable {
  Set<EventAttachment> _attachments = new Set();

  EventDispatcher() {}

  EventAttachment listen(void handler(P params)) {
    EventAttachment attachment = new EventAttachment(this, handler);
    _attachments.add(attachment);
    return attachment;
  }

  void destroy() {
    purge();
    super.destroy();
  }

  void cancel(EventAttachment attachment) {
    _attachments.remove(attachment);
  }

  void purge() {
    _attachments.clear();
  }

  void fire([P params]) {
    List<EventAttachment> attachments = _attachments.toList(growable: false);
    for (EventAttachment attachment in _attachments) {
      attachment.handler(params);
    }
  }
}