part of insync;

class PropertyFunctor<T> extends Owner {
  final List<Property> sources;
  final Function _func;

  Property<T> _target;
  Property<T> get target => _target;

  PropertyFunctor(this.sources, this._func, {Property<T> target}) {
    _target = (target != null) ? target : new Property<T>()..ownBy(this);
    _update();
    sources.forEach(watch);
  }

  void listen(EventDispatcher dispatcher) {
    own(dispatcher.listen(_update));
  }

  void watch(Property property) {
    listen(property.onChange);
  }

  void _update([dynamic p]) {
    _target.value = Function.apply(_func, sources.map((Property source) => source.value).toList());
  }
}