part of insync;

class Property<V> extends Destroyable {
  bool _ownsValue = false;
  PropertyCopier<V> _copier;

  final EventDispatcher<ValueChangeEventParams<V>> onChange =
      new EventDispatcher<ValueChangeEventParams<V>>();

  V _value;
  V get value => _value;
  void set value(V value) {
    V oldValue = _value;
    if (oldValue == value) {
      return;
    }
    _value = value;
    onChange.fire(new ValueChangeEventParams<V>(value, oldValue));
    if (_ownsValue && (oldValue != null)) {
      (oldValue as Destroyable).destroy();
    }
  }

  Property([this._value]);

  void destroy() {
    this.bindTo();
    if (_ownsValue && (_value != null)) {
      (_value as Destroyable).destroy();
    }
    super.destroy();
  }

  void ownValue() {
    _ownsValue = true;
  }

  void bindTo([Property<V> source]) {
    if (this._copier != null) {
      this._copier.destroy();
      this._copier = null;
    }
    if (source != null) {
      this._copier = new PropertyCopier<V>(source, target: this);
    }
  }
}