part of insync;

class ComponentInserter extends Destroyable {
  Element _el;
  AbstractListInserter<Component> _inserter;

  ComponentInserter(AbstractList<Component> source, this._el) {
    _inserter = source.createInserter(add: _add, remove: _remove);
  }

  void destroy() {
    _inserter.destroy();
    super.destroy();
  }

  void _add(Component component, int index) {
    _el.children.insert(index, component.el);
    component._afterAppend();
  }

  void _remove(Component component, int index) {
    component.el.remove();
  }
}