part of insync;

class AttrUpdater extends Destroyable {
  final Element el;
  final String attr;
  final Property<String> property;

  EventAttachment _attachment;

  AttrUpdater(this.el, this.attr, this.property) {
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    String value = property.value;
    if (value != null) {
      el.attributes[attr] = property.value;
    } else {
      el.attributes.remove(attr);
    }
  }
}