part of insync;

class RadioListener extends Owner {
  final Element el;
  final String name;

  Property<String> _target;
  Property<String> get target => _target;

  String _selector;

  RadioListener(this.el, this.name, {Property<String> target}) {
    _target = (target != null) ? target : new Property<String>()..ownBy(this);
    _selector = 'input[type=radio][name="' + name + '"]:checked';
    _update();
    own(new Subscription(el.onChange.listen(_update)));
  }

  void _update([Event event]) {
    InputElement radioEl = el.querySelector(_selector);
    _target.value = (radioEl != null) ? radioEl.attributes['value'] : null;
  }
}