part of insync;

class VisibleUpdater extends Destroyable {
  final Element el;
  final Property<bool> property;

  EventAttachment _attachment;

  VisibleUpdater(this.el, this.property) {
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    if (property.value) {
      el.style.removeProperty('display');
    } else {
      el.style.display = 'none';
    }
  }
}