import 'dart:html';
import '../../../lib/insync.dart';

class Hello extends Component {
  final Property<String> name = new Property<String>('man');

  String get templateId => 'Hello';
  String get template =>
      '<div prefix="greeter">'
        '<p>Your name: <input type="text" id="input"></p>'
        '<div id="greeting"></div>'
      '</div>';

  Map<String, Function> get renderers => super.renderers..addAll({
    'input': renderInput,
    'greeting': renderGreeting
  });

  void renderInput(Element el) {
    own(new ValueUpdater(el, name));
    own(new ValueListener(el, target: name));
  }

  void renderGreeting(Element el) {
    Property<String> text = (new PropertyFunctor<String>([name],
        (String name) => 'Hello, ' + name + '!')..ownBy(this)).target;
    own(new TextUpdater(el, text));
  }
}

void main() {
  new Hello().renderTo(document.body);
}